

/****************************************************************
*			Hi-Tech workshop exercise Lab1						*
*****************************************************************
m LAB1 - Template File.c iH@{d

m߸̡Ap]w Configuration Words, EEPROM lȡAID ]w

b MPALB IDE UAsĶ\iH[ COnfiguration Bits ˬd
]wȤ[ ID Memory Zҳ]w ID ȡC
EEPROM l]wȥiHb View --> EEPROM Uݨ즹]wȡC
HWTس]wȷ|bsĶ\᪽H HEX 覡sb{XAN
{ɷ|@_N PIC16F887 ̪C

{泡Nϥ Protues Ӽ檺GA` PORTD 
LED |Cj 200mS ۰ʥ[@AU SW2 (RB0)|N PORTD ksC
 
*****************************************************************/

#include <pic.h>				// processor if/def file


//**********************************
//* Function Prototype Declaration
//**********************************
void Init_System(void);
void Delay_x_mS(int);
void Delay_1mS(void);

// ================================================================
// **** Establish PIC16F887 Configuration Word
// UԲӳ]weаѦ : pic16f887.h ̪
// 

__CONFIG ( FOSC_INTRC_CLKOUT & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & CPD_OFF &
           BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_OFF ); 

__CONFIG ( BOR4V_BOR40V & WRT_OFF );


// ]w EEPROM Nl

__EEPROM_DATA 	(0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07);
__EEPROM_DATA	(0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f);
__EEPROM_DATA	('H','i','-','T','e','c','h',0x00,);

// ]w 4 Ʀb ID Location m

__IDLOC  ( 12AB );


#define SW2 PORTBbits.RB0

// =================================================================

/*****************************
    INITIALIZE SYSTEM
*****************************/

void Init_System(void)
{
	PORTD = 0x00;				// Initialize PORTD latch states
	TRISD = 0x00;				// set PORTD as outputs
	ANSEL = 0x00;				// Turn off all Analog Input pin for I/O function
	ANSELH = 0x00;
};

//*********************************
//*    Delay Routine with 8MHz
//*********************************

void Delay_x_mS( int N_mS )
{
		int	Loop_mS ;
		
		for ( Loop_mS = 0 ; Loop_mS < N_mS ; Loop_mS++ ) 
		{
			Delay_1mS();	
		}
		 
}

//*** Delay 1mS with 8MHz crystal

void Delay_1mS(void)
{
		int Del_1mS;

		for (Del_1mS = 0 ; Del_1mS < 90  ; Del_1mS ++ )
		{
			NOP( );
			NOP( );
		}
}
	
/*******************************************************************
                  MAIN PROGRAM BEGINS HERE
********************************************************************/

void main( void )
{
	IRCF0=1;					//Select Internal FRC at 8MHz in the OSCCON Register
	IRCF1=1;
	IRCF2=1;

	Init_System();				// Initialize System Function and Variables

	while(1)  					// Infinite loop
	{
		if (SW2)
		{ 
			Delay_x_mS(200);		// Delay 200mS
			PORTD++;				// Increment PortD
		}
		else PORTD = 0;
		
	};
}
