
/****************************************************************
*			Hi-Tech workshop exercise Lab2						*
*****************************************************************
mߥDnOϥ pic16f887.h ɮ׸̩ҩwqPW٤Φ줸ϥ

{̦ SW2 & SW3 n骺uBzASW3 UW[@ASW2 U
hU@C

PORTD P LED  LCD @ΡAb MID_LCD.c {SOBz@
PORTD {Cm߱Nݤ LED & LCD ۤzZΡC
 
*****************************************************************/

#include <pic.h>				// processor if/def file
#include "MID_LCD.h"

//**********************************
//* Function Prototype Declaration
//**********************************


// ================================================================
// **** Establish PIC16F887 Configuration Word
// UԲӳ]weаѦ : pic16f887.h ̪
// 

__CONFIG ( FOSC_INTRC_CLKOUT & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & CPD_OFF &
           BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_OFF ); 

__CONFIG ( BOR4V_BOR40V & WRT_OFF );



#define	SW3	RA4
#define SW2	RB0

const char LCD_Msg1[]="Hi-Tech PICC Ex2"; 
const char LCD_Msg2[]=" Up:00  Down:00 "; 
unsigned char i;
unsigned char debounce =0;
unsigned char Up_Count=0;
unsigned char Down_Count=0;



/*****************************
    INITIALIZE SYSTEM
*****************************/

void Init_System(void)
{
	ANSEL=0;				// Disable All Analog input function
	ANSELH=0;		 

	PORTD=0x00;
	TRISD=0x00;				// Set PortD for LED Output
	TRISA2 = 0; 			// Output pin function for the Enable pin of LCD Module 
		 
	TRISA4=1;				// Set SW2 for input
	TRISE1=1;				// Set SW6 for Input
}

//***************************************
//*             Program Main ( )		*
//***************************************
void main(void)
{
 	IRCF0=1;					//Select Internal FRC at 8MHz in the OSCCON Register
	IRCF1=1;
	IRCF2=1;

	Init_System();
	OpenLCD();
	PORTD = 0x80;
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_Msg1);
	LCD_Set_Cursor(0,1);
	putrsLCD(LCD_Msg2);

	while(1)
	{
		if (debounce==0)			// uBz?
			{
				if (!SW3) 			// ˬd SW3 O_U?
					{
						PORTD++;
						LCD_Set_Cursor(4,1);
						puthexLCD(++Up_Count);
						debounce=20;	// SW3 UA]wuBzƬ 20 
					}
				if (!SW2) 			// ˬd SW2 O_U?
					{
						PORTD--;
						LCD_Set_Cursor(13,1);
						puthexLCD(--Down_Count);
						debounce=20;	// SW2 UA]wuBzƬ 20 
					}
			}
		else						// uBz
			{
				if (SW3 & SW2) 		// ˬdҦO_}F?
					{
						debounce--;	// }FAuP_ƴ@An Delay
						for (i=0;i<50;i++);
					}
				else 				// 䤴AuBzAP_ 20 
					debounce=20;	
			}		 
	}
	
}


