
/****************************************************************
*			Hi-Tech workshop exercise Lab3						*
*****************************************************************
m߱Nϥ union & struct 覡өѩβզX ADC ഫ᪺ 10-bit
ơAñNഫȰe LCDWܡC

AD ഫGe CCP2  PWM XAunվ VR1 NiHbܪi
ݨ PWM XiΡC

*****************************************************************/

#include <pic.h>				// processor if/def file
#include "mid_lcd.h"

//**********************************
//* Function Prototype Declaration
//**********************************
void Init_IO(void);
void Init_Adc( void );
void A2D( unsigned char );
void LCD_ItoA(unsigned int);

unsigned char Set_BCD_ASCII(unsigned char);
unsigned int i;

// ================================================================
// **** Establish PIC16F887 Configuration Word
// UԲӳ]weаѦ : pic16f887.h ̪
// 

__CONFIG ( FOSC_INTRC_CLKOUT & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & CPD_OFF &
           BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_OFF ); 

__CONFIG ( BOR4V_BOR40V & WRT_OFF );

// =================================================================


const char LCD_Msg1[]=" A/D Result:    "; 
const char LCD_Msg2[]="  MSB:   LSB:   "; 

unsigned int AD_Temp;
bit DS_Zero_Flag;

union  	{
		int AD_10bit;
		struct	{
				char AD_LSB;
				char AD_MSB;
				}AD_Byte;
		}AD_Int;				// AD ഫ Buffer


/*****************************
    INITIALIZE I/O PORT
*****************************/

void Init_IO(void)
{
	TRISD=0x00;				// Set PortD for Output
	PORTD=0x80;				// Initila LED display = 0x80
	
	ANSEL = 0x00;			// Turn Off all analog input pin
	ANSELH = 0x00;
}


/*****************************************
    Initialize A/D & Comparator Module
******************************************/

void Init_Adc( void )
{
	ANS0 = 1;				// Set RA0 as AD input pin

	ADCON1=0b10000000;		// Right justified, Vref+ = Vdd, Vref- = Vss 
	ADCON0=0b10000001; 		// Tad = Fosc/32, Select AN0, A/D on
}    
           
void Init_PWM2(void)
{
	T2CON = 0b00000000;		// ]w Timer 2 
	PR2 = 0xFF;				// PWM Period = 0xFF (8-bit PWM Mode)
	TMR2IE = 0;
	TMR2ON =1;				// Ұ Timer 2

	CCP2CON = 0b00001100;	// ]w PWM X\
	CCPR2L = 0x80;			// ȳ] 50% Duty Cycle Optput
	TRISC1 = 0;				// ]w CCP2 pin as Output

}                            
/***********************************
        Convert A/D Channel
************************************/

void A2D( unsigned char channel )
{
	unsigned char temp;				// Temp storage

	temp = channel << 2;			// Shift channel value three bits left
	ADCON0 &= 0b11000011;			// Clear channel select bits in ADCON0
	ADCON0 |= temp;					// Logically OR shifted channel value into place in ADCON0
 
	GO_DONE = 1;						// Initiate conversion on selected channel
	NOP( );
	while (GO_DONE) ;					// Poll ADGO bit until it clears, indicating conv. done
	AD_Int.AD_Byte.AD_MSB=ADRESH;
	AD_Int.AD_Byte.AD_LSB=ADRESL;
} 

//***************************************
//*             Program Main ( )		*
//***************************************
void main(void)
{
	IRCF0=1;					//Select Internal FRC at 8MHz in the OSCCON Register
	IRCF1=1;
	IRCF2=1;

	Init_IO();
	Init_PWM2();
	Init_Adc();
	OpenLCD();
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_Msg1);
	LCD_Set_Cursor(0,1);
	putrsLCD(LCD_Msg2);

	while(1)
	{
		A2D(0x00);							// Get 10-bit A/D result from CH0

		CCPR2L = AD_Int.AD_10bit >>2;		// X̰ 8-bit AD ഫȰPWM Duty Cycle
		LCD_Set_Cursor(12,0);
		LCD_ItoA(AD_Int.AD_10bit);			// AD ȥHQi覡ܦb LCD Ĥ@
		LCD_Set_Cursor(6,1);
		puthexLCD(AD_Int.AD_Byte.AD_MSB);  	// AD  MSB  2 bit.
		LCD_Set_Cursor(13,1);
		puthexLCD(AD_Int.AD_Byte.AD_LSB);	//  LSB  8-bit ȡC

		for (i=0; i<10000;i++);
	}
	
}

void LCD_ItoA(unsigned int AD_Data)
{
		AD_Temp=AD_Data;
	    DS_Zero_Flag=1;

		putcLCD(Set_BCD_ASCII(AD_Data/1000));		// ܤd
		AD_Temp=AD_Temp%1000;						// XʦH᪺

		putcLCD(Set_BCD_ASCII(AD_Temp/100));		// ܦʦ
		AD_Temp=AD_Temp%100;
	
		putcLCD(Set_BCD_ASCII(AD_Temp/10));			// ܤQ
		AD_Temp=AD_Temp%10;

		putcLCD(AD_Temp+='0');						// ܭӦ
}

unsigned char Set_BCD_ASCII(unsigned char BCD_Data)
{
		if (BCD_Data==0) 
		{
			if (DS_Zero_Flag) return ' ';   	// ~s
			else	return '0';					// ܤ@몺s
		}
		else 
		{
			DS_Zero_Flag=0;						// ~s	
			return (BCD_Data +='0');			// öǦ^ ASCII Code
		}		
}
