

/****************************************************************
*			Hi-Tech workshop exercise Lab6						*
*****************************************************************
mߨϥ Timer2 ]wC 10mS _@A_Ƹ̦AP_ 100mS
ɶ}l LED VBVkʪ]OC												 	
*****************************************************************/

#include <pic.h>				// processor if/def file
 

//**********************************
//* Function Prototype Declaration
//**********************************
void interrupt isr_Sevr ( void );

// ================================================================
// **** Establish PIC16F887 Configuration Word
// UԲӳ]weаѦ : pic16f887.h ̪
// 

__CONFIG ( FOSC_INTRC_CLKOUT & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & CPD_OFF &
           BOREN_OFF & IESO_OFF & FCMEN_OFF & LVP_OFF ); 

__CONFIG ( BOR4V_BOR40V & WRT_OFF );

// =================================================================

volatile near unsigned char Long_Count ;
volatile near unsigned char Direct_LED ;
volatile near unsigned char Dir_Count ;

void main(void)
{
		IRCF0=1;					//Select Internal FRC at 8MHz in the OSCCON Register
		IRCF1=1;
		IRCF2=1;

		TRISD=0x00;					// Set output port for LED driver
		PORTD=0b00000001;			// Set b0 of LED is On

		T2CON=0b01111110;			// Timer2 On, Postscale=16, Prescale=16
		TMR2IE=1;					// Enable Timer2 Interrupt
		PEIE=1;						// Set Timer2 for High Priority
		GIE=1;						// Enable High Priority Interrupt
		PR2 = 77;					//(8Mhz/4) [16*16*(77+1)] = 10mS 

		Long_Count=0;
		Direct_LED=0;
		Dir_Count=0;

		while(1);					// Loop Here!
}


//***********************************************
//*  		Interrupt Service Routine			*       
//***********************************************

void interrupt isr_Sevr ( void )
 
{
	TMR2IF=0;							// Clear Timer2 interrupt Flag

	if (Long_Count <=9) Long_Count++;  // 10mS * 10 = 100mS
	else
	{	
		Long_Count=0;					// Time is 100mS, do the function

		if (Direct_LED==0x00)			// Right or Left shift
		{
		 	PORTD<<=1;					// LED left shift
			Dir_Count++;
			if (Dir_Count==7) 			// End of LED position?
			{
				Dir_Count=0;			// Yes, set flag of right shift
				Direct_LED=0x1;
			}
		}
		else
		{
			PORTD>>=1;					// LED right shift
			Dir_Count++;
			if (Dir_Count==7) 
			{
				Dir_Count=0;
				Direct_LED=0x00;
			}
		}
	}		
}								








